%bcond_without sys_llvm
%bcond_without check

%global toolchain clang

%global maj_ver 15
%global min_ver 0
%global patch_ver 7
%global polly_version %{maj_ver}.%{min_ver}.%{patch_ver} 
%global polly_srcdir polly-%{polly_version}.src

%if %{with sys_llvm}
%global pkg_name polly
%global bin_suffix %{nil}
%global install_prefix %{_prefix}
%else
%global pkg_name polly%{maj_ver}
%global bin_suffix -%{maj_ver}
%global install_prefix %{_libdir}/llvm%{maj_ver}
%endif

%global install_includedir %{install_prefix}/include
%global install_libdir %{install_prefix}/%{_lib}
%global install_docdir %{install_prefix}/share/doc

Name:    %{pkg_name}
Version: %{polly_version}
Release: 1
Summary: LLVM Framework for High-Level Loop and Data-Locality Optimizations

License: NCSA
URL: http://polly.llvm.org
Source0: https://github.com/llvm/llvm-project/releases/download/llvmorg-%{polly_version}/%{polly_srcdir}.tar.xz
Source1: https://github.com/llvm/llvm-project/releases/download/llvmorg-%{polly_version}/%{polly_srcdir}.tar.xz.sig

Patch0: 0001-fedora-PATCH-polly-Portability-of-subproject-extension.patch

BuildRequires: cmake

%if %{with sys_llvm}
BuildRequires: llvm-devel = %{version}
BuildRequires: llvm-test = %{version}
BuildRequires: clang-devel = %{version}
%else
BuildRequires: llvm%{maj_ver}-devel = %{version}
BuildRequires: llvm%{maj_ver}-test = %{version}
BuildRequires: clang-devel%{maj_ver} = %{version}
%endif

%if "%toolchain" == "clang"
BuildRequires: clang
BuildRequires: clang-tools-extra
%endif

BuildRequires: ninja-build
BuildRequires: python3-lit
BuildRequires: python3-sphinx

%description
Polly is a high-level loop and data-locality optimizer and optimization
infrastructure for LLVM. It uses an abstract mathematical representation based
on integer polyhedron to analyze and optimize the memory access pattern of a
program.

	
%package devel
Summary: Polly header files
Requires: %{name} = %{version}-%{release}
 
%description devel
Polly header files.
 
%prep
%autosetup -n %{polly_srcdir} -p2

%build
%cmake 	-GNinja \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DLLVM_LINK_LLVM_DYLIB:BOOL=ON \
	-DLLVM_EXTERNAL_LIT=%{_bindir}/lit \
	-DCMAKE_PREFIX_PATH=%{install_libdir}/cmake/llvm/ \
\
	-DLLVM_ENABLE_SPHINX:BOOL=ON \
	-DSPHINX_WARNINGS_AS_ERRORS=OFF \
	-DSPHINX_EXECUTABLE=%{_bindir}/sphinx-build-3 \
\
%if 0%{?__isa_bits} == 64
	-DLLVM_LIBDIR_SUFFIX=64
%else
	-DLLVM_LIBDIR_SUFFIX=
%endif
 
%ninja_build

%install
%ninja_install
 
%check
 
%files
%license LICENSE.TXT
%{install_libdir}/LLVMPolly.so
%{install_libdir}/libPolly.so.*
%{install_libdir}/libPollyISL.so
 
%files devel
%{install_libdir}/libPolly.so
%{install_includedir}/polly
%{install_libdir}/cmake/polly

%changelog
* Sun Aug 27 2023 cf-zhao <zhaochuanfeng@huawei.com> - 15.0.7-1
- Initial version.
